﻿-- Author      : Administrator
-- Create Date : 10/19/2014 1:45:47 AM



local function ButtonSetClick()	
	OptionsSimpleVisible();
end

local function ButtonDoubleClick()
	DobuleConfigChange();
end

local methods = {
	["Refresh"] = function(self)
		self.buttonSet:ClearAllPoints();
		self.buttonDouble:ClearAllPoints();
		if ( Default_Settings.buttonLoc.location == 0 ) then			
			self.buttonSet:SetPoint("TOPRIGHT",self.relative,"TOPLEFT",-Default_Settings.buttonLoc.space,0);
			self.buttonDouble:SetPoint("TOP",self.buttonSet,"BOTTOM");
		elseif ( Default_Settings.buttonLoc.location == 1 ) then
			self.buttonSet:SetPoint("BOTTOMLEFT",self.relative,"TOPLEFT",0,Default_Settings.buttonLoc.space);
			self.buttonDouble:SetPoint("LEFT",self.buttonSet,"RIGHT");
		elseif ( Default_Settings.buttonLoc.location == 2 ) then
			self.buttonSet:SetPoint("BOTTOMRIGHT",self.relative,"TOPRIGHT",0,Default_Settings.buttonLoc.space);
			self.buttonDouble:SetPoint("RIGHT",self.buttonSet,"LEFT");
		elseif ( Default_Settings.buttonLoc.location == 3 ) then
			self.buttonSet:SetPoint("TOPLEFT",self.relative,"TOPRIGHT",Default_Settings.buttonLoc.space,0);
			self.buttonDouble:SetPoint("TOP",self.buttonSet,"BOTTOM");
		elseif ( Default_Settings.buttonLoc.location == 4 ) then
			self.buttonSet:SetPoint("BOTTOMLEFT",self.relative,"BOTTOMRIGHT",Default_Settings.buttonLoc.space,0);
			self.buttonDouble:SetPoint("BOTTOM",self.buttonSet,"TOP");
		elseif ( Default_Settings.buttonLoc.location == 5 ) then
			self.buttonSet:SetPoint("TOPRIGHT",self.relative,"BOTTOMRIGHT",0,-Default_Settings.buttonLoc.space);
			self.buttonDouble:SetPoint("RIGHT",self.buttonSet,"LEFT");
		elseif ( Default_Settings.buttonLoc.location == 6 ) then
			self.buttonSet:SetPoint("TOPLEFT",self.relative,"BOTTOMLEFT",0,-Default_Settings.buttonLoc.space);
			self.buttonDouble:SetPoint("LEFT",self.buttonSet,"RIGHT");
		else
			self.buttonSet:SetPoint("BOTTOMRIGHT",self.relative,"BOTTOMLEFT",-Default_Settings.buttonLoc.space,0);
			self.buttonDouble:SetPoint("BOTTOM",self.buttonSet,"TOP");
		end		
		self.buttonSet:Show();
		if Default_Settings.backup.enabledflag then
			self.buttonDouble:Show();
		else
			self.buttonDouble:Hide();
		end	
	end,
	["Hide"] = function(self)
		self.buttonSet:Hide();
		self.buttonDouble:Hide();
	end
}

function ConstructorButton(relative)
	local buttonSet = CreateFrame("Frame",nil,UIParent);
	buttonSet:SetFrameStrata("BACKGROUND")
	buttonSet:SetWidth(16) -- Set these to whatever height/width is needed 
	buttonSet:SetHeight(16) -- for your Texture
	local buttonSetf = buttonSet:CreateTexture(nil,"BACKGROUND")
	buttonSetf:SetTexture("INTERFACE\\GLUES\\CharacterSelect\\Glues-AddOn-Icons.blp",true)
	buttonSetf:SetTexCoord(0.75,1,0,1);
	buttonSetf:SetAllPoints(buttonSet)
	buttonSet.texture = buttonSetf	
	buttonSet:SetScript("OnMouseDown",ButtonSetClick);

	local buttonDouble = CreateFrame("Frame",nil,UIParent);
	buttonDouble:SetFrameStrata("BACKGROUND")
	buttonDouble:SetWidth(16) -- Set these to whatever height/width is needed 
	buttonDouble:SetHeight(16) -- for your Texture
	local buttonDoublef = buttonDouble:CreateTexture(nil,"BACKGROUND")
	buttonDoublef:SetTexture("INTERFACE\\\TARGETINGFRAME\\UI-TargetingFrame-Seal.blp",true)
	buttonDoublef:SetTexCoord(0.2,0.8,0.2,0.8);
	buttonDoublef:SetAllPoints(buttonDouble)
	buttonDouble.texture = buttonDoublef
	buttonDouble:SetScript("OnMouseDown",ButtonDoubleClick);

	local widget = {
		buttonSet	= buttonSet,
		buttonDouble = buttonDouble,
		relative = relative
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end
	return widget;
end