﻿-- Author      : Administrator
-- Create Date : 10/18/2014 2:05:14 PM
local K = KeepSpell;
local _mMainFrame = ConstructorMainFrame();
local _mOptions = ConstructorOptions();
local _mOptionsSimple = ConstructorOptionsSimple();
local _mButton = ConstructorButton(_mMainFrame.framemain);
local _ActionFlag = nil;
local _mTableInfo = {};
local _mTableSubSum = {};
local _mRaidFlag = false;
local _mBuffFilter = nil;

do
	local i = 1;
	while i <= 40 do
		local temp ={	
			subgroup = 0;
			partyindex = 0;
			barindex = 0;
			nowvalue = {0,0,0}};
		_mTableInfo[i] = temp;
		i = i + 1
	end
	i = 1;
	while i <= 8 do
		_mTableSubSum[i] = 0;
		i = i + 1;
	end
end


function OptionsVisible()
	InterfaceOptionsFrame_OpenToCategory("iShield")
end

function OptionsIsShow()
	if _mOptionsSimple.framemain:IsShown() then
	else
		OptionsSimpleVisible()
	end
end

function FrameRestore()
	_mMainFrame:Cernter();
end

function OptionsSimpleVisible()
	if _mOptionsSimple.framemain:IsShown() then
	
		if _mOptions.framemain:IsVisible() then
			--DEFAULT_CHAT_FRAME:AddMessage("OptionsSimpleVisible IsShown")
		else
			_mOptionsSimple.framemain:Hide();
			_mMainFrame:LockFrame(true);
			checkRaid();
			_mMainFrame.framemain:RegisterEvent("GROUP_ROSTER_UPDATE");
		end
	else		
		--DEFAULT_CHAT_FRAME:AddMessage("UNIT_AURA close1")
		_mMainFrame.framemain:UnregisterEvent("UNIT_AURA");
		_mMainFrame.framemain:UnregisterEvent("GROUP_ROSTER_UPDATE");
		_mOptionsSimple.framemain:Show();
		_mMainFrame.framemain:Show();
		_mMainFrame:LockFrame(false);
		

	end
end

function FrameSizeChange()
	_mMainFrame:RefreshSize();
end

function FrameColorChange()
	_mMainFrame:RefreshColor();
end

function ButtonChange()
	_mButton:Refresh();
end

function ModelChange()
	_mMainFrame:RefreshSize();
	BuffFilterChange();
	_mMainFrame:SaveLocation();
end

function BuffFilterChange()
	if Default_Settings.modelown == true then
		_mBuffFilter = "player"
	else
		_mBuffFilter = nil
	end
end

function DobuleConfigChange()
	if _mOptionsSimple.framemain:IsShown() then
	else	
		local v1,v2,v3,v4,v5,v6,v7,v8 = Default_Settings.backup.selflocation[1],Default_Settings.backup.selflocation[2],Default_Settings.backup.selfsize.width,Default_Settings.backup.selfsize.height,Default_Settings.backup.selfsize.columnspace,Default_Settings.backup.selfsize.linespace,Default_Settings.backup.buttonLoc.location,Default_Settings.backup.buttonLoc.space

		Default_Settings.backup.selflocation[1] = Default_Settings.selflocation[1]
		Default_Settings.backup.selflocation[2] = Default_Settings.selflocation[2]
		Default_Settings.backup.selfsize.width = Default_Settings.selfsize.width
		Default_Settings.backup.selfsize.height = Default_Settings.selfsize.height
		Default_Settings.backup.selfsize.columnspace = Default_Settings.selfsize.columnspace
		Default_Settings.backup.selfsize.linespace = Default_Settings.selfsize.linespace
		Default_Settings.backup.buttonLoc.location = Default_Settings.buttonLoc.location
		Default_Settings.backup.buttonLoc.space = Default_Settings.buttonLoc.space
		Default_Settings.selflocation[1] = v1
		Default_Settings.selflocation[2] = v2
		Default_Settings.selfsize.width = v3
		Default_Settings.selfsize.height = v4
		Default_Settings.selfsize.columnspace = v5
		Default_Settings.selfsize.linespace = v6
		Default_Settings.buttonLoc.location = v7
		Default_Settings.buttonLoc.space = v8
		_mMainFrame:RefreshSize();
		_mOptionsSimple:LoaderUserData();
		_mButton:Refresh();
	end
end
function checkRaid()
	local tempflag = UnitInRaid("player");
	local tempaction = false;
	if tempflag and tempflag > 0 then
		_mRaidFlag = true;
		tempaction = true;				
	else
		_mRaidFlag = false;
		tempflag = UnitInParty("player");
		if tempflag then
			tempaction = true;
		end
	end
	
	if _ActionFlag ~= tempaction then
		_ActionFlag = tempaction;
		if _ActionFlag then
			_mMainFrame.framemain:Show();
			_mButton:Refresh();
		else
			_mMainFrame.framemain:Hide();
			_mButton:Hide();
		end
	end
	if _ActionFlag then
		refreshRaid();
		_mMainFrame:BarVisible(false);
		--DEFAULT_CHAT_FRAME:AddMessage("UNIT_AURA open")
		_mMainFrame.framemain:RegisterEvent("UNIT_AURA");
	else
		--DEFAULT_CHAT_FRAME:AddMessage("UNIT_AURA close2")
		_mMainFrame.framemain:UnregisterEvent("UNIT_AURA");
	end
end
function refreshRaid()
	--DEFAULT_CHAT_FRAME:AddMessage("refreshRaid start")
	local i = 1;
	local tablesum = 0;
	while i <= 8 do
		_mTableSubSum[i] = 0;
		i = i + 1;
	end
	i = 1;
	local playname,_,subgroup = GetRaidRosterInfo(i);
	while playname do
		_mTableSubSum[subgroup] = _mTableSubSum[subgroup] + 1;
		_mTableInfo[i]["activation"] = true;
		_mTableInfo[i]["subgroup"] = subgroup;
		_mTableInfo[i]["partyindex"] = _mTableSubSum[subgroup];
		_mTableInfo[i]["barindex"] = (subgroup-1) * 5 + _mTableSubSum[subgroup];
		_mTableInfo[i]["nowvalue"][1] = 0;
		_mTableInfo[i]["nowvalue"][2] = 0;
		_mTableInfo[i]["nowvalue"][3] = 0;
		i = i + 1;
		playname,_,subgroup = GetRaidRosterInfo(i);
	end
	tablesum = i-1;
	if Default_Settings.modelblank then
		i = 1
		while i <= 8 do
			if _mTbaleSubSum[i] == 0 then
				local j = 1;
				while j <= tablesum do
					if _mTableInfo[i]["subgroup"] > j then
						_mTableInfo[i]["barindex"] = _mTableInfo[i]["barindex"] - 5;
					end
					j = j + 1
				end
			end
			i = i + 1;
		end
	end
	--DEFAULT_CHAT_FRAME:AddMessage("refreshRaid end")
	--[[i = 1
	while i <= tablesum do
		DEFAULT_CHAT_FRAME:AddMessage(GetRaidRosterInfo(i).." "..tostring(i).." group"..tostring(_mTableInfo[i]["subgroup"]).."index"..tostring(_mTableInfo[i]["barindex"]));
		i = i + 1;
	end]]
end

local function Frame_OnEvent(self, event, ...)
	if event == "UNIT_AURA" then
		local playername = select(1, ...);
		local raidindex = 0;
		if _mRaidFlag then
			local _,findflag = string.find(playername, "raid");
			if findflag > 0 then
				raidindex = UnitInRaid(playername);
			end
		else
			raidindex = 1;
			if playername ~= "player" then
				raidindex = tonumber(string.sub(playername, 6, 6)) + 1;					
			end
		end
		
		if raidindex > 0 then
			local all,magic,physical = 0,0,0;			
			local indexflag = 1;
			local spellid,value = 0 ,0;
			_, _, _, _, _, _, _, _, _, _, spellid, _, _, _, value = UnitBuff(..., indexflag,_mBuffFilter);			
			while spellid do
				if K.SpellInfo[spellid] ~= nil and Default_Settings.unkeepspell[spellid] ~= true then
					if K.SpellInfo[spellid][1] then
						magic = magic + value
					end
					if K.SpellInfo[spellid][2] then
						physical = physical + value
					end					
				end
				indexflag = indexflag + 1
				_, _, _, _, _, _, _, _, _, _, spellid, _, _, _, value = UnitBuff(..., indexflag,_mBuffFilter);
			end	
			if magic > 0 and physical >0 then
				if magic >= physical then
					all = physical;
					physical = 0;
					magic = magic - all;
				else
					all = magic;
					physical = physical - all;
					magic = 0;
				end
			end
			if Default_Settings.shieldmax > 0 then
				all = math.ceil(all * 100 / Default_Settings.shieldmax)/100;
				physical = math.ceil(physical * 100 / Default_Settings.shieldmax)/100;
				magic = math.ceil(magic * 100 / Default_Settings.shieldmax)/100;
			else
				local healthMax = UnitHealthMax(...);
				all = math.ceil(all * 100 / healthMax)/100;
				physical = math.ceil(physical * 100 / healthMax)/100;
				magic = math.ceil(magic * 100 / healthMax)/100;
			end			
			if _mTableInfo[raidindex].nowvalue[1] ~= all or _mTableInfo[raidindex].nowvalue[2] ~= physical or _mTableInfo[raidindex].nowvalue[3] ~= magic then
				_mTableInfo[raidindex].nowvalue[1] = all
				_mTableInfo[raidindex].nowvalue[2] = physical
				_mTableInfo[raidindex].nowvalue[3] = magic
				--_mMainFrame:PrintValue(_mTableInfo[raidindex]["barindex"],magic,0,magic)
				_mMainFrame:PrintValue(_mTableInfo[raidindex]["barindex"],all,physical,magic)
			end
			--DEFAULT_CHAT_FRAME:AddMessage("UNIT_AURA "..tostring(raidindex).." all:"..tostring(_mTableInfo[raidindex].nowvalue[1]).." magic:"..tostring(_mTableInfo[raidindex].nowvalue[2]).." physical:"..tostring(_mTableInfo[raidindex].nowvalue[3]));
		end		
	else
		if event == "GROUP_ROSTER_UPDATE" then
			checkRaid()
		else
			if event == "ADDON_LOADED" and select(1, ...) == "iShield" then
				_mMainFrame.framemain:UnregisterEvent("ADDON_LOADED");
				loadDefault();
				_mMainFrame:RefreshSize();
				_mOptions:LoaderUserData();
				_mOptionsSimple:LoaderUserData();
				_mButton:Refresh();
				_mMainFrame:LockFrame(true);
				BuffFilterChange();
				checkRaid();
			end
		end
	end
end



_mMainFrame.framemain:SetScript("OnEvent", Frame_OnEvent);
_mMainFrame.framemain:RegisterEvent("ADDON_LOADED");
_mMainFrame.framemain:RegisterEvent("GROUP_ROSTER_UPDATE");



--_mMainFrame:BarVisible(false)